home *** CD-ROM | disk | FTP | other *** search
/ Chip 2007 January, February, March & April / Chip-Cover-CD-2007-02.iso / Pakiet bezpieczenstwa / mini Pentoo LiveCD 2006.1 / mpentoo-2006.1.iso / livecd.squashfs / usr / libexec / mozilla-launcher < prev    next >
Text File  |  2006-05-08  |  19KB  |  599 lines

  1. #!/bin/bash
  2. # $Header: /var/cvsroot/gentoo-src/mozilla-launcher/mozilla-launcher,v 1.49 2006/03/06 20:40:14 agriffis Exp $
  3. #
  4. # Portions of this file are extracted from the mozilla.org distributed scripts.
  5. # Those portions are Copyright (C) 1998 Netscape Communmications Corporation and
  6. # released under the NPL as detailed in /usr/lib/mozilla/mozilla,
  7. # /usr/lib/MozillaFirefox/firefox and /usr/lib/MozillaThunderbird/thunderbird.
  8. #
  9. # The remainder of this file is Copyright 1999-2005 Gentoo Foundation
  10. # Distributed under the terms of the GNU General Public License v2
  11.  
  12. : ${MOZILLA_LAUNCHER_DEBUG:=false}
  13.  
  14. # Make sure necessary progs are in the PATH
  15. PATH=/usr/bin:/bin:/usr/X11R6/bin:$PATH
  16.  
  17. main() {
  18.   declare args mozargs urls u i mozpid debugger debugging=false
  19.   declare candidates retval=0 progname
  20.   declare zero=${0##*/}
  21.  
  22.   # We'd like to believe that we were called via one of the symlinks in
  23.   # /usr/bin.  However OOo sports some questionable behavior: it follows the
  24.   # symlinks instead of relying on UNIX filesystem semantics, so $zero is
  25.   # "/usr/libexec/mozilla-launcher" in that case.  We workaround this
  26.   # misbehavior by using a stub in /usr/bin instead of a symlink.  The stub sets
  27.   # MOZILLA_LAUNCHER and execs /usr/libexec/mozilla-launcher
  28.   [[ -n $MOZILLA_LAUNCHER ]] && zero=$MOZILLA_LAUNCHER
  29.   unset MOZILLA_LAUNCHER
  30.  
  31.   # Determine if we're called as firefox or mozilla and set up
  32.   # variables appropriately
  33.   which_browser || exit 1       # note: modifies $zero
  34.  
  35.   # Parse the command-line and set args, mozargs and urls
  36.   parse_cmdline "$@" || exit 1
  37.  
  38.   # Make sure we'll get at least an empty window/tab
  39.   # when nothing else is specified on the cmdline.
  40.   if [[ $# -eq 0 && ${#mozargs[@]} == 0 ]]; then
  41.     if [[ $zero == sunbird* ]]; then
  42.       mozargs=-calendar
  43.     else
  44.       urls=('')
  45.     fi
  46.   fi
  47.  
  48.   # Set the candidates array with find_running
  49.   find_running
  50.  
  51.   # Handle some special args.  We want to handle these ourselves so
  52.   # that we can find the right window on the screen to target.
  53.   set -- "${mozargs[@]}"
  54.   while [[ $# -gt 0 ]]; do
  55.     case $1 in
  56.       -mail)    try_running 'xfeDoCommand(openInbox)' ;;
  57.       -compose)
  58.         if [[ -n $2 ]]; then
  59.           try_running "xfeDoCommand(composeMessage,$2)" && shift
  60.         else
  61.           try_running "xfeDoCommand(composeMessage)"
  62.         fi ;;
  63.       -remote)  try_running "$2" && shift ;;
  64.       *) false ;;
  65.     esac
  66.     [[ $? -eq 0 ]] && { shift; continue; }
  67.     # Error path: try_running failed, so prepend remaining mozargs to
  68.     # args and drop through to call the browser binary
  69.     args=("$@" "${args[@]}")
  70.     break
  71.   done
  72.  
  73.   # If there's no running browser, or we've got args, start an
  74.   # instance.
  75.   if [[ ${#args[@]} -gt 0 ]] || ! try_running 'ping()'; then
  76.     # Assume the first url should just be tacked on the end.
  77.     try_start "${args[@]}" ${urls:+"${urls[0]}"} || exit
  78.     mozpid=$!
  79.     set -- "${urls[@]}"; shift; urls=("$@")   # shift off the first url
  80.     candidates=$DISPLAY
  81.     args=()
  82.  
  83.     # Handle case of multiple URLs by waiting for browser to map to
  84.     # the screen so that it can be found by $remote below
  85.     if [[ ${#urls[@]} -gt 0 ]]; then
  86.       if [[ -x /usr/bin/xtoolwait ]]; then
  87.         xtoolwait sleep 10      # hope it hasn't mapped yet
  88.       else
  89.         sleep 1
  90.         for ((i = 0; i < 40; i = i + 1)); do
  91.           try_running 'ping()' && break || sleep 0.25
  92.         done
  93.       fi
  94.     fi
  95.   fi
  96.  
  97.   # Handle multiple URLs by looping over the xremote call
  98.   for u in "${urls[@]}"; do
  99.     if [[ $u == mailto:* ]]; then
  100.       try_running "mailto(${u#mailto:})" || retval=$?
  101.     else
  102.       if [[ -n $MOZILLA_NEWTYPE ]]; then
  103.         try_running "openURL($u,new-$MOZILLA_NEWTYPE)" || retval=$?
  104.       elif [[ $zero == firefox* && -n $u ]]; then
  105.         # Don't override preferences set in the browser #82653
  106.         try_running "openURL($u)" || retval=$?
  107.       elif [[ -n $u ]]; then
  108.         try_running "openURL($u,new-window)" || retval=$?
  109.       else
  110.         try_running "xfeDoCommand(openBrowser)" || retval=$?
  111.       fi
  112.     fi
  113.   done
  114.  
  115.   # Will only wait here if browser was started by this script
  116.   if [[ -n ${mozpid} ]]; then
  117.     wait ${mozpid}
  118.     retval=$?
  119.     [[ ${retval} == 0 ]] \
  120.       || echo "${mozbin##*/} exited with non-zero status (${retval})" >&2
  121.     moz_pis_startstop_scripts stop
  122.   fi
  123.  
  124.   exit $retval
  125. }
  126.  
  127. which_browser() {
  128.   # Newer launcher stubs will set MOZILLA_LIBDIR so that the installation
  129.   # location is controlled by the ebuild rather than mozilla-launcher, finally!
  130.   if [[ ! -d $MOZILLA_LIBDIR ]]; then
  131.     unset MOZILLA_LIBDIR
  132.   fi
  133.  
  134.   # Support mozilla, mozilla-bin, firefox, firefox-bin, thunderbird,
  135.   # thunderbird-bin!
  136.   # This case statement does the setup for source-based browsers and
  137.   # just drops through for binary-based browsers.
  138.   case $zero in
  139.     *fox)
  140.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/usr/lib/MozillaFirefox"}
  141.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  142.       mozbin=$MOZILLA_FIVE_HOME/firefox-bin
  143.       ;;
  144.  
  145.     *mozilla)
  146.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/usr/lib/mozilla"}
  147.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  148.       mozbin=$MOZILLA_FIVE_HOME/mozilla-bin
  149.       ;;
  150.  
  151.     *sunbird)
  152.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/usr/lib/MozillaSunbird"}
  153.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  154.       mozbin=$MOZILLA_FIVE_HOME/sunbird-bin
  155.       ;;
  156.  
  157.     *thunderbird)
  158.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/usr/lib/MozillaThunderbird"}
  159.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  160.       mozbin=$MOZILLA_FIVE_HOME/thunderbird-bin
  161.       ;;
  162.  
  163.     *seamonkey)
  164.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/usr/lib/seamonkey"}
  165.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  166.       mozbin=$MOZILLA_FIVE_HOME/seamonkey-bin
  167.       ;;
  168.  
  169.     *-bin)
  170.       unset mozbin  # just in case...
  171.       ;;            # but don't do anything yet
  172.  
  173.     *)
  174.       echo "$0: unknown browser" >&2
  175.       return 1
  176.       ;;
  177.   esac
  178.  
  179.   # Attempt to use -bin version if source version isn't available
  180.   if [[ -n $mozbin && ! -f $mozbin ]]; then
  181.     unset mozbin        # it's bogus anyway
  182.     zero=${zero}-bin
  183.   fi
  184.  
  185.   case $zero in
  186.     *fox-bin)
  187.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/opt/firefox"}
  188.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  189.       mozbin=$MOZILLA_FIVE_HOME/firefox-bin
  190.       ;;
  191.  
  192.     *mozilla-bin)
  193.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/opt/mozilla"}
  194.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  195.       mozbin=$MOZILLA_FIVE_HOME/mozilla-bin
  196.       ;;
  197.  
  198.     *sunbird-bin)
  199.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/opt/sunbird"}
  200.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  201.       mozbin=$MOZILLA_FIVE_HOME/sunbird-bin
  202.       ;;
  203.  
  204.     *thunderbird-bin)
  205.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/opt/thunderbird"}
  206.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  207.       mozbin=$MOZILLA_FIVE_HOME/thunderbird-bin
  208.       ;;
  209.  
  210.     *seamonkey-bin)
  211.       export MOZILLA_FIVE_HOME=${MOZILLA_LIBDIR:-"/opt/seamonkey"}
  212.       remote=$MOZILLA_FIVE_HOME/mozilla-xremote-client
  213.       mozbin=$MOZILLA_FIVE_HOME/seamonkey-bin
  214.       ;;
  215.   esac
  216.  
  217.   # Make sure we got something
  218.   if [[ -z $mozbin || ! -f $mozbin ]]; then
  219.     echo "$0: can't find the browser :-(" >&2
  220.     return 1
  221.   fi
  222.  
  223.   # Newer xremote has the ability to specify a target program.  Base
  224.   # this on ${zero} but workaround bug 247754 for thunderbird
  225.   progname=${zero%-bin}
  226.   if [[ $progname == thunderbird ]]; then
  227.     grep -q '"0\.[78]"' ${MOZILLA_FIVE_HOME}/defaults/pref/*.js \
  228.       && progname=Thunderbird
  229.   fi
  230.  
  231.   # Set LD_LIBRARY_PATH (also set in /etc/env.d/10*)
  232.   export LD_LIBRARY_PATH=$MOZILLA_FIVE_HOME:$MOZILLA_FIVE_HOME/plugins${LD_LIBRARY_PATH:+:$LD_LIBRARY_PATH}
  233.  
  234.   # Make sure netscape-compatible plugins are picked up
  235.   [[ -z $MOZ_PLUGIN_PATH ]] && export MOZ_PLUGIN_PATH=/usr/lib/nsbrowser/plugins
  236.  
  237.   return 0
  238. }
  239.  
  240. # parse_cmdline: set args, mozargs and urls, which are dynamically
  241. # scoped in main()
  242. parse_cmdline() {
  243.   # Validate the args and extract the urls
  244.   args=()         # general arguments
  245.   mozargs=()      # arguments that we handle specifically
  246.   urls=()         # urls to open
  247.   while [[ $# -ne 0 ]] ; do
  248.     if [[ $1 == -* ]] ; then
  249.       case "${1#-}" in
  250.         # options we handle specially
  251.         g|-debug)
  252.           debugging=true
  253.           shift 1 ;;
  254.         d|-debugger)
  255.           debugging=true
  256.           debugger=$2
  257.           shift 2 ;;
  258.         a)
  259.           # ignore -a which xfhelp4 passes for no reason
  260.           shift 2 ;;
  261.         register)
  262.           # just do this immediately
  263.           update_chrome
  264.           exit $? ;;
  265.         unregister)
  266.           # just do this immediately
  267.           remove_chrome
  268.           exit $? ;;
  269.         # mozargs with 0 arguments
  270.         mail)
  271.           mozargs=("${mozargs[@]}" "$1")
  272.           shift 1 ;;
  273.         # mozargs with 0 or 1 arguments
  274.         compose|remote)
  275.           if [[ -n $2 ]]; then
  276.             mozargs=("${mozargs[@]}" "$1" "$2")
  277.             shift 2
  278.           else
  279.             mozargs=("${mozargs[@]}" "$1")
  280.             shift 1
  281.           fi ;;
  282.         # options we pass through 1 argument
  283.         height|width|CreateProfile|P|UILocale|contentLocale|edit|chrome)
  284.           args=("${args[@]}" "$1" "$2")
  285.           shift 2 ;;
  286.         # unrecognized options are simply passed through
  287.         *)
  288.           args=("${args[@]}" "$1")
  289.           shift 1 ;;
  290.       esac
  291.     else
  292.       if [[ $1 == *://*/* ]]; then
  293.         urls=("${urls[@]}" "$1")
  294.       elif [[ $1 == *://* ]]; then
  295.         # as of mozilla_1.7_rc1 the url checking changed for xremote
  296.         # calls... now three slashes are required for urls, otherwise we
  297.         # get the following error from xremote:
  298.         #  Error: Failed to send command: 509 internal error
  299.         urls=("${urls[@]}" "$1/")
  300.       elif [[ $1 != /* && -e $1 ]]; then
  301.         # relative path to a file, transform to URL syntax
  302.         urls=("${urls[@]}" "file://$PWD/$1")
  303.       elif [[ $1 == /* && -e $1 ]]; then
  304.         # absolute path to a file, transform to URL syntax
  305.         urls=("${urls[@]}" "file://$1")
  306.       elif [[ $1 != *:* && $1 == *@* ]]; then
  307.         # looks like an email address, prefix with mailto: so we can
  308.         # recognize it later.
  309.         urls=("${urls[@]}" "mailto:$1")
  310.       else
  311.         # no idea what this is!  just add it to urls and hope it works
  312.         urls=("${urls[@]}" "$1")
  313.       fi
  314.       shift
  315.     fi
  316.   done
  317.  
  318.   return 0
  319. }
  320.  
  321. # find_running: sets the candidates array
  322. find_running() {
  323.   declare screens s
  324.  
  325.   # Try to start in an existing session; check all screens
  326.   # with priority on the current screen
  327.   screens=("$DISPLAY"
  328.     $(xdpyinfo | awk '
  329.       /^name of display:/ {
  330.         disp = substr($NF, 0, match($NF, /\.[^.]*$/)-1)
  331.       }
  332.       /^number of screens:/ {
  333.         for (i = 0; i < $NF; i++) {
  334.           this = sprintf("%s.%d", disp, i)
  335.           if (this != ENVIRON["DISPLAY"])
  336.             print this
  337.         }
  338.       }')
  339.     )
  340.  
  341.   # We used to check displays with xwininfo here but that isn't
  342.   # necessary with the advent of -a programname.
  343.   # Instead just test for a running program if we're on a local
  344.   # display.
  345.   if [[ $DISPLAY != :* ]] || killall -0 ${mozbin##*/} &>/dev/null; then
  346.     candidates=("${screens[@]}")
  347.   else
  348.     candidates=()
  349.   fi
  350. }
  351.  
  352. # try_running: try to use an existing browser to run a command
  353. try_running() {
  354.   declare s retval=2  # default == can't find an instance
  355.  
  356.   # Try mozilla-xremote-client on each candidate screen.
  357.   for s in "${candidates[@]}"; do
  358.     DISPLAY=$s $remote -a ${progname} "$@"
  359.     retval=$?
  360.     if [[ $retval -eq 0 ]]; then
  361.       candidates=("$s")       # for future calls
  362.       return 0
  363.     fi
  364.   done
  365.  
  366.   # Might as well do this error interpretation here
  367.   case $retval in
  368.     1) echo "Unable to connect to X server" >&2 ;;
  369.     2) echo "No running windows found" >&2 ;;
  370.     3) echo "Browser doesn't understand command" >&2 ;;
  371.     *) echo "Unknown error $retval from mozilla-xremote-client" >&2 ;;
  372.   esac
  373.  
  374.   return $retval
  375. }
  376.  
  377. # set_debugger: set $debugger
  378. set_debugger() {
  379.   declare d
  380.   : ${debugger:=ddd gdb}
  381.  
  382.   # Try to find a workable debugger
  383.   for d in ${debugger}; do
  384.     type -fp $d &>/dev/null || continue
  385.     debugger=$d
  386.     return 0
  387.   done
  388.  
  389.   echo "Can't find debugger (${debugger})" >&2
  390.   exit 1
  391. }
  392.  
  393. # try_start: attempt to start a browser
  394. try_start() {
  395.   declare f
  396.  
  397.   # shouldn't have files in profile that are owned by a user other
  398.   # than the current one.  http://bugs.gentoo.org/show_bug.cgi?id=59849
  399.   f=$(find ~/{.,.mozilla/}${zero%-bin} ! -uid ${EUID} 2>/dev/null | head -n10)
  400.   if [[ -n ${f} ]]; then
  401.     cat <<EOF
  402. Error launching ${zero}:
  403.  
  404. There are files in your profile that are owned by a user other than
  405. $(id -un).  ${zero} can't execute in this condition.  Here are some of
  406. the files that I found:
  407. EOF
  408.     echo "${f}" | sed 's/^/    /'
  409.     (( $(echo "${f}" | wc -l) == 10 )) && echo "    ..."
  410.     echo
  411.     echo "You can fix this problem by running the following:"
  412.     echo "    su -c 'chown -R $(id -un):$(id -gn) $HOME/.mozilla'"
  413.     echo
  414.     return 101
  415.   fi >&2
  416.  
  417.   # compreg.dat and/or chrome.rdf will screw things up if it's from an
  418.   # older version.  http://bugs.gentoo.org/show_bug.cgi?id=63999
  419.   for f in ~/{.,.mozilla/}${zero%-bin}/*/{compreg.dat,chrome.rdf,XUL.mfasl}; do
  420.     if [[ -f ${f} && ${f} -ot ${mozbin} ]]; then
  421.       echo "Removing ${f} leftover from older ${zero%-bin}"
  422.       rm -f "${f}"
  423.     fi
  424.   done
  425.  
  426.   moz_pis_startstop_scripts start
  427.  
  428.   if $debugging && set_debugger; then
  429.     for v in MOZILLA_FIVE_HOME LD_LIBRARY_PATH LD_LIBRARYN32_PATH \
  430.         LD_LIBRARYN64_PATH LD_LIBRARY_PATH_64 DISPLAY XPSERVERLIST \
  431.         MOZILLA_POSTSCRIPT_PRINTER_LIST DYLD_LIBRARY_PATH LIBRARY_PATH \
  432.         SHLIB_PATH LIBPATH ADDON_PATH MOZ_PROGRAM MOZ_TOOLKIT debugger; do
  433.       [[ -n ${!v} ]] && printf "%31s=%s\n" "$v" "${!v}"
  434.     done
  435.     echo
  436.  
  437.     # Note that --args works for gdb and ddd.  Other debuggers will need another
  438.     # method if added to this script.
  439.     "$debugger" --args "$mozbin" "$@"
  440.  
  441.     # Don't try to load additional URLs if debugging
  442.     unset urls
  443.   else
  444.     "$mozbin" "$@" &
  445.   fi
  446. }
  447.  
  448. moz_pis_startstop_scripts() {
  449.   eval $(grep -m1 MOZ_USER_DIR= $MOZILLA_FIVE_HOME/${zero%-bin})
  450.   if [[ -z $MOZ_USER_DIR ]]; then
  451.     echo "Warning: Couldn't extract MOZ_USER_DIR from $MOZILLA_FIVE_HOME/$zero"
  452.     return
  453.   fi
  454.   # MOZ_PIS_ is the name space for "Mozilla Plugable Init Scripts"
  455.   # These variables and there meaning are specified in
  456.   # mozilla/xpfe/bootstrap/init.d/README
  457.   MOZ_PIS_API=2
  458.   MOZ_PIS_MOZBINDIR="${dist_bin}"
  459.   MOZ_PIS_SESSION_PID="$$"
  460.   MOZ_PIS_USER_DIR="${MOZ_USER_DIR}"
  461.   export MOZ_PIS_API MOZ_PIS_MOZBINDIR MOZ_PIS_SESSION_PID MOZ_PIS_USER_DIR
  462.  
  463.   case "${1}" in
  464.     "start")
  465.       for curr_pis in "${dist_bin}/init.d"/S* "${HOME}/${MOZ_USER_DIR}/init.d"/S* ; do
  466.         if [ -x "${curr_pis}" ] ; then
  467.           case "${curr_pis}" in
  468.             *.sh) .  "${curr_pis}"         ;;
  469.             *)       "${curr_pis}" "start" ;;
  470.           esac
  471.         fi
  472.       done
  473.       ;;
  474.     "stop")
  475.       for curr_pis in "${HOME}/${MOZ_USER_DIR}/init.d"/K* "${dist_bin}/init.d"/K* ; do
  476.         if [ -x "${curr_pis}" ] ; then
  477.           case "${curr_pis}" in
  478.             *.sh) . "${curr_pis}"        ;;
  479.             *)      "${curr_pis}" "stop" ;;
  480.           esac
  481.         fi
  482.       done
  483.       ;;
  484.     *)
  485.       echo 1>&2 "$0: Internal error in moz_pis_startstop_scripts."
  486.       exit 1
  487.       ;;
  488.   esac
  489. }
  490.  
  491. remove_chrome() {
  492.   if [[ $UID != 0 ]]; then
  493.     echo "$0: You need to be root to update the registry" >&2
  494.     return 1
  495.   fi
  496.  
  497.   rm -rf ${MOZILLA_FIVE_HOME}/chrome/overlayinfo
  498.   rm -f  ${MOZILLA_FIVE_HOME}/chrome/chrome.rdf
  499.   rm -f  ${MOZILLA_FIVE_HOME}/extensions/installed-extensions-processed.txt 
  500.   rm -f  ${MOZILLA_FIVE_HOME}/extensions/Extensions.rdf
  501.   rm -f  ${MOZILLA_FIVE_HOME}/extensions/installed-extensions.txt
  502.   rm -f  ${MOZILLA_FIVE_HOME}/chrome/installed-chrome.txt
  503.  
  504.   return 0
  505. }
  506.  
  507. update_chrome() {
  508.   if [[ $UID != 0 ]]; then
  509.     echo "$0: You need to be root to update the registry" >&2
  510.     return 1
  511.   fi
  512.  
  513.   # The -bin packages don't support updating the registry, at least not yet.
  514.   # regxpcom and regchrome are missing from firefox-bin and thunderbird-bin, and
  515.   # there should be no need to run mozilla-rebuild-databases.pl with mozilla-bin
  516.   if [[ ${zero} == *-bin ]]; then
  517.     echo "$0: update_chrome doesn't support ${zero}"
  518.     return 1
  519.   fi
  520.  
  521.   # mozilla (seamonkey) doesn't support -register yet.  Until it does, use the
  522.   # mozilla-rebuild-databases.pl script instead
  523.   if [[ ${zero} == mozilla ]]; then
  524.     echo "Running mozilla-rebuild-databases.pl"
  525.     umask 022
  526.     ${MOZILLA_FIVE_HOME}/mozilla-rebuild-databases.pl
  527.     return $?
  528.   elif [[ ${zero} == seamonkey ]]; then
  529.     echo "Running seamonkey-rebuild-databases.pl"
  530.     umask 022
  531.     ${MOZILLA_FIVE_HOME}/seamonkey-rebuild-databases.pl
  532.     return $?
  533.   fi
  534.  
  535.   echo "Updating ${zero} chrome registry..."
  536.   umask 022
  537.   export PATH=${MOZILLA_FIVE_HOME}:${PATH}
  538.   export HOME=$(mktemp -d /tmp/${zero}-register.XXXXXX)
  539.   declare libdir=${MOZILLA_FIVE_HOME}
  540.   declare extdir=${libdir}/extensions.d
  541.   declare chrdir=${libdir}/chrome.d
  542.  
  543.   # set up libdir
  544.   remove_chrome || return 1
  545.   mkdir -p ${libdir}/chrome/overlayinfo
  546.   mkdir -p ${libdir}/extensions
  547.  
  548.   # generate installed-extensions.txt
  549.   :> ${libdir}/extensions/installed-extensions.txt
  550.   chmod 0644 ${libdir}/extensions/installed-extensions.txt
  551.   for f in $(ls -d ${extdir}/* 2>/dev/null); do
  552.     while read line; do
  553.       extuid=$(echo ${line} | cut -f 2 -d ,)
  554.       extuiddir=${libdir}/extensions/${extuid}
  555.       if [[ ! -e ${extuiddir} ]]; then
  556.         echo "W: ${f}: ${extuiddir} doesn't exist." >&2
  557.       elif [[ ! -e ${extuiddir}/install.rdf ]]; then
  558.         echo "W: ${f}: ${extuiddir}/install.rdf doesn't exist." >&2
  559.       elif grep -Fq ${extuid} ${extuiddir}/install.rdf; then
  560.         echo $line >> ${libdir}/extensions/installed-extensions.txt
  561.       else
  562.         echo "W: ${f}: ${extuiddir}/install.rdf doesn't contain the UID." >&2
  563.       fi
  564.     done < $f
  565.   done
  566.  
  567.   # do some double-checking
  568.   if $MOZILLA_LAUNCHER_DEBUG; then
  569.     for f in $(find ${libdir}/extensions/ -maxdepth 1 -name '{*}'); do
  570.       if ! grep -Fq ${f##*/} ${libdir}/extensions/installed-extensions.txt; then
  571.         echo "W: ${f##*/} not in ${libdir}/extensions/installed-extensions.txt" >&2
  572.       fi
  573.     done
  574.   fi
  575.  
  576.   # generate installed-chrome.txt
  577.   cat /dev/null $(ls -d ${chrdir}/* 2>/dev/null) > ${libdir}/chrome/installed-chrome.txt
  578.   chmod 0644 ${libdir}/chrome/installed-chrome.txt
  579.  
  580.   # let the mozilla binary do its thing...
  581.   $mozbin -register || echo "E: Registration process exited with status: $?" >&2
  582.   regchrome || echo "E: regchrome exited with status: $?" >&2
  583.   regxpcom || echo "E: regxpcom exited with status: $?" >&2
  584.  
  585.   if [[ -e ${libdir}/extensions/installed-extensions.txt ]]; then
  586.     echo "E: ${libdir}/extensions/installed-extensions.txt still present" >&2
  587.     echo "E: Registration might have gone wrong" >&2
  588.   fi
  589.  
  590.   rm -fr ${HOME}
  591.  
  592.   return 0
  593. }
  594.  
  595. # Call the main sub, which is defined at the top of this script
  596. main "$@"
  597.  
  598. # vim:expandtab sw=2:
  599.